freeslot(
	"SPR_SPAU",
	"SPR_SSJA",
	"SPR_SSJF",
	"SPR_SS2O",
	"SPR_SSGA",
	"SPR_SSBA",
	"SPR_SSBB",
	"SPR_SSBE",
	"SPR_SRAA",
	"SPR_SSRA",
	"SPR_SGSA",
	"SPR_UIAU",
	"SPR_UICA",
	"SPR_UIOV",
	"SPR_MUIO",
	"SPR_FARA",
	"SPR_BTSA",
	"SPR_BTSO",
	"SPR_STHA",
	"SPR_STHO",
	"SPR_THSA",
	"SPR_THSO",
	"SPR_FPTH"
)

if not SFA_AuraStyles
	rawset(_G, "SFA_AuraStyles", {})
end

SFA_AuraStyles["ssj"] = {
	name = "Super Saiyan",
	sprite = SPR_SSJA,
	frames = 3,
	tics = 3,
	scale = FixedDiv(5*FRACUNIT, 4*FRACUNIT)
}
SFA_AuraStyles["ssjf"] = {
	name = "Super Saiyan (with light color filling)",
	sprite = SPR_SSJF,
	frames = 3,
	tics = 3,
	scale = FixedDiv(5*FRACUNIT, 4*FRACUNIT)
}
SFA_AuraStyles["ssj2"] = {
	name = "Super Saiyan 2",
	sprite = SPR_SSJA,
	frames = 3,
	tics = 3,
	scale = FixedDiv(5*FRACUNIT, 4*FRACUNIT),
	overlay = SPR_SS2O,
	overlay_frames = 6,
	overlay_tics = 3,
	overlay_scale = FixedDiv(3*FRACUNIT, 2*FRACUNIT)
}
SFA_AuraStyles["ssj2f"] = {
	name = "Super Saiyan 2 (with light color filling)",
	sprite = SPR_SSJF,
	frames = 3,
	tics = 3,
	scale = FixedDiv(5*FRACUNIT, 4*FRACUNIT),
	overlay = SPR_SS2O,
	overlay_frames = 6,
	overlay_tics = 3,
	overlay_scale = FixedDiv(3*FRACUNIT, 2*FRACUNIT)
}
SFA_AuraStyles["ssjalt"] = {
	name = "Super Saiyan (Roll the Dice)",
	sprite = SPR_SPAU,
	frames = 4,
	tics = 2
}
SFA_AuraStyles["ssg"] = {
	name = "Super Saiyan God",
	sprite = SPR_SSGA,
	frames = 3,
	tics = 3
}
SFA_AuraStyles["ssb"] = {
	name = "Super Saiyan Blue",
	sprite = SPR_SSBA,
	frames = 3,
	tics = 3,
	scale = FRACUNIT+FRACUNIT/8
}
SFA_AuraStyles["ssbbc"] = {
	name = "Super Saiyan Blue (Berserk Controlled)",
	sprite = SPR_SSBB,
	frames = 3,
	tics = 3,
	scale = FRACUNIT+FRACUNIT/8
}
SFA_AuraStyles["ssbe"] = {
	name = "Super Saiyan Blue Evolution",
	sprite = SPR_SSBE,
	frames = 3,
	tics = 3,
	scale = FRACUNIT+FRACUNIT/8
}
SFA_AuraStyles["ssrage"] = {
	name = "Super Saiyan Rage",
	sprite = SPR_SRAA,
	frames = 3,
	tics = 3,
	scale = FRACUNIT+FRACUNIT/8
}
SFA_AuraStyles["ssr"] = {
	name = "Super Saiyan Rose",
	sprite = SPR_SSRA,
	frames = 3,
	tics = 3,
	scale = FRACUNIT+FRACUNIT/8
}
SFA_AuraStyles["ssgss"] = {
	name = "Super Saiyan God Super Saiyan (colorizable)",
	sprite = SPR_SGSA,
	frames = 3,
	tics = 3,
	scale = FRACUNIT+FRACUNIT/4
}
SFA_AuraStyles["ui"] = {
	name = "Ultra Instinct",
	sprite = SPR_UIAU,
	frames = 6,
	tics = 2,
	overlay = SPR_UIOV,
	overlay_frames = 3,
	overlay_tics = 4,
	overlay_blending = AST_ADD,
	overlay_rescalable = false
}
SFA_AuraStyles["uic"] = {
	name = "Ultra Instinct (original from Roll the Dice, colorizable)",
	sprite = SPR_UICA,
	frames = 6,
	tics = 2
}
SFA_AuraStyles["mui"] = {
	name = "Mastered Ultra Instinct",
	sprite = SPR_UIAU,
	frames = 6,
	tics = 2,
	blending = AST_ADD,
	overlay = SPR_MUIO,
	overlay_frames = 3,
	overlay_tics = 4,
	overlay_blending = AST_ADD,
	overlay_rescalable = false
}
SFA_AuraStyles["firesonic"] = {
	name = "Fire Sonic (Roll the Dice)",
	sprite = SPR_FARA,
	frames = 3,
	tics = 2,
	scale = FixedDiv(27*FRACUNIT, 20*FRACUNIT)
}
SFA_AuraStyles["btss"] = {
	name = "Berserker True Super Sonic (SQFP)",
	sprite = SPR_BTSA,
	frames = 3,
	tics = 2,
	overlay = SPR_BTSO,
	overlay_frames = 9,
	overlay_tics = 2,
	overlay_opacity = FF_TRANS30
}
SFA_AuraStyles["sths"] = {
	name = "Semi-True Hyper Sonic (SQFP)",
	sprite = SPR_STHA,
	frames = 3,
	tics = 2,
	overlay = SPR_STHO,
	overlay_frames = 9,
	overlay_tics = 2,
	overlay_opacity = FF_TRANS30
}
SFA_AuraStyles["ths"] = {
	name = "True Hyper Sonic (SQFP)",
	sprite = SPR_THSA,
	frames = 4,
	tics = 2,
	scale = FixedDiv(3*FRACUNIT, 5*FRACUNIT),
	overlay = SPR_THSO,
	overlay_frames = 4,
	overlay_tics = 2,
	overlay_scale = FixedDiv(6*FRACUNIT, 5*FRACUNIT),
	overlay_opacity = FF_TRANS30
}
SFA_AuraStyles["fpths"] = {
	name = "Full Power True Hyper Sonic (SQFP)",
	sprite = SPR_FPTH,
	frames = 8,
	tics = 2,
	scale = FixedDiv(3*FRACUNIT, 4*FRACUNIT)
}