//Aura state definition
freeslot("S_SUPERAURA", "S_AURAOVERLAY", "S_SUPERAURA2", "S_AURAOVERLAY2")
states[S_SUPERAURA] = {
	sprite = SPR_SSJA,
	frame = A|FF_FULLBRIGHT,
	var1 = 1,
	nextstate = S_SUPERAURA
}

states[S_AURAOVERLAY] = {
	sprite = SPR_SPAU,
	frame = A|FF_FULLBRIGHT,
	var1 = 0,
	nextstate = S_AURAOVERLAY
}

states[S_SUPERAURA2] = {
	sprite = SPR_SSJA,
	frame = A|FF_FULLBRIGHT,
	var1 = 0,
	nextstate = S_SUPERAURA2
}

states[S_AURAOVERLAY2] = {
	sprite = SPR_SPAU,
	frame = A|FF_FULLBRIGHT,
	var1 = 0,
	nextstate = S_AURAOVERLAY2
}

freeslot("S_GLOWOL")
states[S_GLOWOL] = {SPR_NULL, A, 2, nil, 1, 0, S_NULL}

//Function to make a mobj's sprite have a glowing outline
//Must be run every tic
local function SFA_SpawnOutline(mo, color)
	local ol1 = P_SpawnMobj(mo.x, mo.y, mo.z, MT_OVERLAY)
	local ol2 = P_SpawnMobj(mo.x, mo.y, mo.z, MT_OVERLAY)
	local ol3 = P_SpawnMobj(mo.x, mo.y, mo.z, MT_OVERLAY)
	local ol4 = P_SpawnMobj(mo.x, mo.y, mo.z, MT_OVERLAY)
	
	ol1.target = mo
	ol2.target = mo
	ol3.target = mo
	ol4.target = mo
	
	ol1.state = S_GLOWOL
	ol2.state = S_GLOWOL
	ol3.state = S_GLOWOL
	ol4.state = S_GLOWOL
	
	ol1.skin = mo.skin
	ol2.skin = mo.skin
	ol3.skin = mo.skin
	ol4.skin = mo.skin
	
	ol1.color = color
	ol2.color = color
	ol3.color = color
	ol4.color = color
	
	ol1.sprite = mo.sprite
	ol2.sprite = mo.sprite
	ol3.sprite = mo.sprite
	ol4.sprite = mo.sprite
	
	ol1.sprite2 = mo.sprite2
	ol2.sprite2 = mo.sprite2
	ol3.sprite2 = mo.sprite2
	ol4.sprite2 = mo.sprite2
	
	ol1.rollangle = mo.rollangle
	ol2.rollangle = mo.rollangle
	ol3.rollangle = mo.rollangle
	ol4.rollangle = mo.rollangle
	
	ol1.fuse = 2
	ol2.fuse = 2
	ol3.fuse = 2
	ol4.fuse = 2
	
	ol1.colorized = true
	ol2.colorized = true
	ol3.colorized = true
	ol4.colorized = true
	
	ol1.scale = mo.scale
	ol2.scale = mo.scale
	ol3.scale = mo.scale
	ol4.scale = mo.scale
	
	ol1.spritexoffset = mo.spritexoffset+FRACUNIT
	ol2.spritexoffset = mo.spritexoffset-FRACUNIT
	ol3.spriteyoffset = mo.spriteyoffset+FRACUNIT
	ol4.spriteyoffset = mo.spriteyoffset-FRACUNIT
	ol1.spriteyoffset = mo.spriteyoffset
	ol2.spriteyoffset = mo.spriteyoffset
	ol3.spritexoffset = mo.spritexoffset
	ol4.spritexoffset = mo.spritexoffset
	
	ol1.spritexscale = mo.spritexscale
	ol2.spritexscale = mo.spritexscale
	ol3.spritexscale = mo.spritexscale
	ol4.spritexscale = mo.spritexscale
	
	ol1.spriteyscale = mo.spriteyscale
	ol2.spriteyscale = mo.spriteyscale
	ol3.spriteyscale = mo.spriteyscale
	ol4.spriteyscale = mo.spriteyscale
end

//Glowing outline thinker
addHook("MobjThinker", function(mo)
	if mo and mo.valid
		if mo.target and mo.target.valid
		and mo.state == S_GLOWOL then
			if mo.target.skin then
				mo.skin = mo.target.skin
			end
			mo.sprite = mo.target.sprite
			mo.sprite2 = mo.target.sprite2
			mo.frame = mo.target.frame|FF_FULLBRIGHT
			mo.blendmode = mo.target.player.outlineblend
			if mo.target.flags2 & MF2_DONTDRAW then
				mo.flags2 = $|MF2_DONTDRAW
			end
		end
	end
end, MT_OVERLAY)

addHook("PlayerThink", function(player)
	if not (player.mo and player.mo.valid) then return end
	
	if player.auraconditions == nil then
		player.auraconditions = 1
	end
	
	if player.auracondbutton then
		if not (player.cmd.buttons & player.auracondbutton) then
			player.auracondswr = true
			player.auracondsw = false
		elseif player.auracondswr then
			player.auracondsw = true
			if player.auraconditions == 0 then
				player.auraconditions = 1
				CONS_Printf(player, "Aura activation conditions set to Super/Sol Form Only")
			elseif player.auraconditions == 1 then
				player.auraconditions = 2
				CONS_Printf(player, "Aura activation conditions set to Always")
			elseif player.auraconditions == 2 then
				player.auraconditions = 0
				CONS_Printf(player, "Aura activation conditions set to Never")
			end
			player.auracondswr = false
		else
			player.auracondsw = false
		end
	end
	
	//Conditions to trigger the aura
	player.cantriggeraura = player.playerstate == PST_LIVE and ((player.auraconditions == 1 and (player.powers[pw_super] or player.nightstime or (player.solchar and player.solchar.istransformed > 0))) or player.auraconditions == 2)
	
	if (player.mo.state != S_PLAY_SUPER_TRANS1
	and player.mo.state != S_PLAY_SUPER_TRANS2
	and player.mo.state != S_PLAY_NIGHTS_TRANS1
	and player.mo.state != S_PLAY_NIGHTS_TRANS2)
	and player.cantriggeraura
	and not (player.auramo and player.auramo.valid) then
		//Activate the aura if conditions are met
		player.auramo = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_OVERLAY)
		if CV_FindVar("sfaura_sounds").value == 1
		and CV_FindVar("sfaura_allowsounds").value == 1 then
			S_StartSound(player.auramo, SFA_SoundSchemes[player.aurasoundsch].transform)
		end
		player.auramo.target = player.mo
		player.auramo.state = S_SUPERAURA
		player.auramo.sprite = SFA_AuraStyles[player.aurastyle].sprite
	end
	if not player.cantriggeraura
	and (player.auramo and player.auramo.valid) then
		//Remove aura if conditions are no longer met
		if CV_FindVar("sfaura_sounds").value == 1 
		and CV_FindVar("sfaura_allowsounds").value == 1 then
			S_StopSoundByID(player.auramo, SFA_SoundSchemes[player.aurasoundsch].passive)
			S_StartSound(player.mo, SFA_SoundSchemes[player.aurasoundsch].detransform)
		end
		P_RemoveMobj(player.auramo)
		if (player.auraovmo and player.auraovmo.valid) then
			P_RemoveMobj(player.auraovmo)
		end
	end
	
	//Second aura
	if (player.auramo and player.auramo.valid)
	and not (player.auramo2 and player.auramo2.valid) then
		player.auramo2 = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_OVERLAY)
		player.auramo2.target = player.mo
		player.auramo2.state = S_SUPERAURA2
		player.auramo2.sprite = SFA_AuraStyles[player.aurastyle2].sprite
	end
	if (player.auramo2 and player.auramo2.valid)
	and not (player.auramo and player.auramo.valid) then
		P_RemoveMobj(player.auramo2)
	end
	
	//Aura overlay
	if (SFA_AuraStyles[player.aurastyle]
	and SFA_AuraStyles[player.aurastyle].overlay != nil
	and SFA_AuraStyles[player.aurastyle].overlay != SPR_NULL)
	and (player.auramo and player.auramo.valid)
	and not (player.auraovmo and player.auraovmo.valid) then
		player.auraovmo = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_OVERLAY)
		player.auraovmo.target = player.mo
		player.auraovmo.tracer = player.mo
		player.auraovmo.state = S_AURAOVERLAY
	end
	if (not (player.auramo and player.auramo.valid)
	or SFA_AuraStyles[player.aurastyle] == nil
	or SFA_AuraStyles[player.aurastyle].overlay == nil
	or SFA_AuraStyles[player.aurastyle].overlay == SPR_NULL)
	and (player.auraovmo and player.auraovmo.valid) then
		P_RemoveMobj(player.auraovmo)
	end
	
	//Second aura overlay
	if (SFA_AuraStyles[player.aurastyle2]
	and SFA_AuraStyles[player.aurastyle2].overlay != nil
	and SFA_AuraStyles[player.aurastyle2].overlay != SPR_NULL)
	and (player.auramo2 and player.auramo2.valid)
	and not (player.auraovmo2 and player.auraovmo2.valid) then
		player.auraovmo2 = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_OVERLAY)
		player.auraovmo2.target = player.mo
		player.auraovmo2.tracer = player.mo
		player.auraovmo2.state = S_AURAOVERLAY2
	end
	if (not (player.auramo2 and player.auramo2.valid)
	or SFA_AuraStyles[player.aurastyle2] == nil
	or SFA_AuraStyles[player.aurastyle2].overlay == nil
	or SFA_AuraStyles[player.aurastyle2].overlay == SPR_NULL)
	and (player.auraovmo2 and player.auraovmo2.valid) then
		P_RemoveMobj(player.auraovmo2)
	end
	
	//Make the player and their followitem unaffected by lightning if they set the sfaura_conditions to "Always"
	if (player.auramo and player.auramo.valid)
	and player.auraconditions == 2 then
		player.mo.renderflags = $|RF_FULLBRIGHT
		if (player.followmobj and player.followmobj.valid) then
			player.followmobj.renderflags = $|RF_FULLBRIGHT
		end
	else
		player.mo.renderflags = $ & ~RF_FULLBRIGHT
		if (player.followmobj and player.followmobj.valid) then
			player.followmobj.renderflags = $ & ~RF_FULLBRIGHT
		end
	end
	
	//Sprite outline
	if (player.mo.state != S_PLAY_SUPER_TRANS1
	and player.mo.state != S_PLAY_SUPER_TRANS2
	and player.mo.state != S_PLAY_NIGHTS_TRANS1
	and player.mo.state != S_PLAY_NIGHTS_TRANS2)
	and player.glowoutline
	and player.cantriggeraura then
		if player.outlinecolor == "player" then
			SFA_SpawnOutline(player.mo, player.mo.color)
		elseif player.outlinecolor == "opposite" then
			SFA_SpawnOutline(player.mo, ColorOpposite(player.mo.color))
		elseif type(player.outlinecolor) == "number" then
			SFA_SpawnOutline(player.mo, player.outlinecolor)
		end
	end
end)

//Thinker for aura
addHook("MobjThinker", function(aura)
	if not (aura and aura.valid)
	or aura.state != S_SUPERAURA then return end
	
	if not (aura.target and aura.target.valid) then
		P_RemoveMobj(aura)
		return
	end
	
	//Timer for passive aura sounds
	if aura.passfxtimer == nil then
		aura.passfxtimer = 0
	end
	aura.passfxtimer = $+1
	
	//Aura frame cycle behavior
	if aura.nextframe == nil then
		aura.nextframe = 0
	end
	aura.frame = aura.nextframe|($ & ~FF_FRAMEMASK)
	if (leveltime % SFA_AuraStyles[aura.target.player.aurastyle].tics == 1) then
		aura.nextframe = $+1
	end
	if aura.nextframe > SFA_AuraStyles[aura.target.player.aurastyle].frames-1 then
		aura.nextframe = 0
	end
	
	if aura.target.player.auraopacity == 0 then
		aura.flags2 = $|MF2_DONTDRAW
	elseif aura.target.player.auraopacity > 0 and aura.target.player.auraopacity < 10
		aura.flags2 = $ & ~MF2_DONTDRAW
		aura.frame = ($ & ~FF_TRANSMASK)|((10-aura.target.player.auraopacity)<<FF_TRANSSHIFT)
	end
	
	//Aura properties
	
	//Aura colors based on current supercolor:
		//Silver: Bone (2)
		//Red: Super Red 5 (122)
		//Orange: Apricot (43)
		//Gold: Yellow (51)
		//Peridot: Peridot (56)
		//Sky: Sky (77)
		//Purple: Super Purple 4 (146)
		//Rust: Copper (42)
		//Tan: Super Tan 4 (156)
	if aura.target.player.auracolor == "player" then
		if aura.target.color >= 113 and aura.target.color <= 117 then
			aura.color = SKINCOLOR_BONE
		elseif aura.target.color >= 118 and aura.target.color <= 122 then
			aura.color = SKINCOLOR_SUPERRED5
		elseif aura.target.color >= 123 and aura.target.color <= 127 then
			aura.color = SKINCOLOR_APRICOT
		elseif aura.target.color >= 128 and aura.target.color <= 132 then
			aura.color = SKINCOLOR_YELLOW
		elseif aura.target.color >= 133 and aura.target.color <= 137 then
			aura.color = SKINCOLOR_PERIDOT
		elseif aura.target.color >= 138 and aura.target.color <= 142 then
			aura.color = SKINCOLOR_SKY
		elseif aura.target.color >= 143 and aura.target.color <= 147 then
			aura.color = SKINCOLOR_SUPERPURPLE4
		elseif aura.target.color >= 148 and aura.target.color <= 152 then
			aura.color = SKINCOLOR_COPPER
		elseif aura.target.color >= 153 and aura.target.color <= 157 then
			aura.color = SKINCOLOR_SUPERTAN4
		else
			aura.color = aura.target.color
		end
	elseif aura.target.player.auracolor == "opposite" then
		aura.color = ColorOpposite(aura.target.color)
	elseif type(aura.target.player.auracolor) == "number" then
		aura.color = aura.target.player.auracolor
	end
	
	if SFA_AuraStyles[aura.target.player.aurastyle].scale != nil then
		aura.spritexscale = FixedMul(aura.target.player.auraxscale, SFA_AuraStyles[aura.target.player.aurastyle].scale)
		aura.spriteyscale = FixedMul(aura.target.player.aurayscale, SFA_AuraStyles[aura.target.player.aurastyle].scale)
	else
		aura.spritexscale = aura.target.player.auraxscale
		aura.spriteyscale = aura.target.player.aurayscale
	end
	
	//Play the aura's passive sound
	if (aura.passfxtimer % SFA_SoundSchemes[aura.target.player.aurasoundsch].passivetics == 1)
	and CV_FindVar("sfaura_sounds").value == 1
	and CV_FindVar("sfaura_allowsounds").value == 1 then
		S_StartSound(aura, SFA_SoundSchemes[aura.target.player.aurasoundsch].passive)
	end
	
	if SFA_AuraStyles[aura.target.player.aurastyle].blending != nil then
		aura.blendmode = SFA_AuraStyles[aura.target.player.aurastyle].blending
	else
		aura.blendmode = aura.target.player.aurablend
	end
end, MT_OVERLAY)

//Thinker for second aura
addHook("MobjThinker", function(aura)
	if not (aura and aura.valid)
	or aura.state != S_SUPERAURA2 then return end
	
	if not (aura.target and aura.target.valid) then
		P_RemoveMobj(aura)
		return
	end
	
	//Aura frame cycle behavior
	if aura.nextframe == nil then
		aura.nextframe = 0
	end
	aura.frame = aura.nextframe|($ & ~FF_FRAMEMASK)
	if (leveltime % SFA_AuraStyles[aura.target.player.aurastyle2].tics == 1) then
		aura.nextframe = $+1
	end
	if aura.nextframe > SFA_AuraStyles[aura.target.player.aurastyle2].frames-1 then
		aura.nextframe = 0
	end
	
	if aura.target.player.auraopacity2 == 0 then
		aura.flags2 = $|MF2_DONTDRAW
	elseif aura.target.player.auraopacity2 > 0 and aura.target.player.auraopacity2 < 10
		aura.flags2 = $ & ~MF2_DONTDRAW
		aura.frame = ($ & ~FF_TRANSMASK)|((10-aura.target.player.auraopacity2)<<FF_TRANSSHIFT)
	end
	
	//Aura properties
	if aura.target.player.auracolor2 == "player" then
		if aura.target.color >= 113 and aura.target.color <= 117 then
			aura.color = SKINCOLOR_BONE
		elseif aura.target.color >= 118 and aura.target.color <= 122 then
			aura.color = SKINCOLOR_SUPERRED5
		elseif aura.target.color >= 123 and aura.target.color <= 127 then
			aura.color = SKINCOLOR_APRICOT
		elseif aura.target.color >= 128 and aura.target.color <= 132 then
			aura.color = SKINCOLOR_YELLOW
		elseif aura.target.color >= 133 and aura.target.color <= 137 then
			aura.color = SKINCOLOR_PERIDOT
		elseif aura.target.color >= 138 and aura.target.color <= 142 then
			aura.color = SKINCOLOR_SKY
		elseif aura.target.color >= 143 and aura.target.color <= 147 then
			aura.color = SKINCOLOR_SUPERPURPLE4
		elseif aura.target.color >= 148 and aura.target.color <= 152 then
			aura.color = SKINCOLOR_COPPER
		elseif aura.target.color >= 153 and aura.target.color <= 157 then
			aura.color = SKINCOLOR_SUPERTAN4
		else
			aura.color = aura.target.color
		end
	elseif aura.target.player.auracolor2 == "opposite" then
		aura.color = ColorOpposite(aura.target.color)
	elseif type(aura.target.player.auracolor2) == "number" then
		aura.color = aura.target.player.auracolor2
	end
	
	if SFA_AuraStyles[aura.target.player.aurastyle2].scale != nil then
		aura.spritexscale = FixedMul(aura.target.player.auraxscale2, SFA_AuraStyles[aura.target.player.aurastyle2].scale)
		aura.spriteyscale = FixedMul(aura.target.player.aurayscale2, SFA_AuraStyles[aura.target.player.aurastyle2].scale)
	else
		aura.spritexscale = aura.target.player.auraxscale2
		aura.spriteyscale = aura.target.player.aurayscale2
	end
	
	if SFA_AuraStyles[aura.target.player.aurastyle2].blending != nil then
		aura.blendmode = SFA_AuraStyles[aura.target.player.aurastyle2].blending
	else
		aura.blendmode = aura.target.player.aurablend2
	end
end, MT_OVERLAY)

//Thinker for aura overlay
addHook("MobjThinker", function(aura)
	if not (aura and aura.valid)
	or aura.state != S_AURAOVERLAY then return end
	
	if not (aura.target and aura.target.valid) then
		P_RemoveMobj(aura)
		return
	end
	
	aura.sprite = SFA_AuraStyles[aura.tracer.player.aurastyle].overlay
	
	//Aura frame cycle behavior
	if aura.nextframe == nil then
		aura.nextframe = 0
	end
	aura.frame = aura.nextframe|($ & ~FF_FRAMEMASK)
	if SFA_AuraStyles[aura.tracer.player.aurastyle].overlay_opacity != nil then
		aura.frame = ($ & ~FF_TRANSMASK)|SFA_AuraStyles[aura.tracer.player.aurastyle].overlay_opacity
	else
		aura.frame = ($ & ~FF_TRANSMASK)
	end
	if (leveltime % SFA_AuraStyles[aura.tracer.player.aurastyle].overlay_tics == 1) then
		aura.nextframe = $+1
	end
	if aura.nextframe > SFA_AuraStyles[aura.tracer.player.aurastyle].overlay_frames-1 then
		aura.nextframe = 0
	end

	if SFA_AuraStyles[aura.tracer.player.aurastyle].overlay_rescalable == true
	or SFA_AuraStyles[aura.tracer.player.aurastyle].overlay_rescalable == nil then
		if SFA_AuraStyles[aura.tracer.player.aurastyle].overlay_scale then
			aura.spritexscale = FixedMul(aura.tracer.player.auraxscale, SFA_AuraStyles[aura.tracer.player.aurastyle].overlay_scale)
			aura.spriteyscale = FixedMul(aura.tracer.player.aurayscale, SFA_AuraStyles[aura.tracer.player.aurastyle].overlay_scale)
		else
			aura.spritexscale = aura.tracer.player.auraxscale
			aura.spriteyscale = aura.tracer.player.aurayscale
		end
	elseif SFA_AuraStyles[aura.tracer.player.aurastyle].overlay_scale then
		aura.spritexscale = SFA_AuraStyles[aura.tracer.player.aurastyle].overlay_scale
		aura.spriteyscale = SFA_AuraStyles[aura.tracer.player.aurastyle].overlay_scale
	else
		aura.spritexscale = FRACUNIT
		aura.spriteyscale = FRACUNIT
	end
	
	if SFA_AuraStyles[aura.tracer.player.aurastyle].overlay_blending != nil then
		aura.blendmode = SFA_AuraStyles[aura.tracer.player.aurastyle].overlay_blending
	else
		aura.blendmode = AST_TRANSLUCENT
	end
	
	aura.target = aura.tracer.player.auramo2
end, MT_OVERLAY)

//Thinker for second aura overlay
addHook("MobjThinker", function(aura)
	if not (aura and aura.valid)
	or aura.state != S_AURAOVERLAY2 then return end
	
	if not (aura.target and aura.target.valid) then
		P_RemoveMobj(aura)
		return
	end
	
	aura.sprite = SFA_AuraStyles[aura.tracer.player.aurastyle2].overlay
	
	//Aura frame cycle behavior
	if aura.nextframe == nil then
		aura.nextframe = 0
	end
	aura.frame = aura.nextframe|($ & ~FF_FRAMEMASK)
	if SFA_AuraStyles[aura.tracer.player.aurastyle2].overlay_opacity != nil then
		aura.frame = ($ & ~FF_TRANSMASK)|SFA_AuraStyles[aura.tracer.player.aurastyle2].overlay_opacity
	else
		aura.frame = ($ & ~FF_TRANSMASK)
	end
	if (leveltime % SFA_AuraStyles[aura.tracer.player.aurastyle2].overlay_tics == 1) then
		aura.nextframe = $+1
	end
	if aura.nextframe > SFA_AuraStyles[aura.tracer.player.aurastyle2].overlay_frames-1 then
		aura.nextframe = 0
	end

	if SFA_AuraStyles[aura.tracer.player.aurastyle2].overlay_rescalable == true
	or SFA_AuraStyles[aura.tracer.player.aurastyle2].overlay_rescalable == nil then
		if SFA_AuraStyles[aura.tracer.player.aurastyle2].overlay_scale then
			aura.spritexscale = FixedMul(aura.tracer.player.auraxscale2, SFA_AuraStyles[aura.tracer.player.aurastyle2].overlay_scale)
			aura.spriteyscale = FixedMul(aura.tracer.player.aurayscale2, SFA_AuraStyles[aura.tracer.player.aurastyle2].overlay_scale)
		else
			aura.spritexscale = aura.tracer.player.auraxscale2
			aura.spriteyscale = aura.tracer.player.aurayscale2
		end
	elseif SFA_AuraStyles[aura.tracer.player.aurastyle2].overlay_scale then
		aura.spritexscale = SFA_AuraStyles[aura.tracer.player.aurastyle2].overlay_scale
		aura.spriteyscale = SFA_AuraStyles[aura.tracer.player.aurastyle2].overlay_scale
	else
		aura.spritexscale = FRACUNIT
		aura.spriteyscale = FRACUNIT
	end
	
	if SFA_AuraStyles[aura.tracer.player.aurastyle2].overlay_blending != nil then
		aura.blendmode = SFA_AuraStyles[aura.tracer.player.aurastyle2].overlay_blending
	else
		aura.blendmode = AST_TRANSLUCENT
	end
	
	aura.target = aura.tracer.player.auramo2
end, MT_OVERLAY)